#include <stdio.h>
#include "fn.h"

#define	MAXPOP	1000

main(int argc,
char **argv)
{
	val v[MAXPOP];
	double m[MAXPOP];
	int pop, cross, mut, gens, gen;
	int i, best;

	if (argc == 5) {
		pop = atoi(argv[1]);
		cross = atoi(argv[2]);
		mut = atoi(argv[3]);
		gens = atoi(argv[4]);
	} else {
		fprintf(stderr,
			"Usage: %s [pop] [cross] [mut] [gens]\n",
			argv[0]);
		exit(1);
	}

	srand(time(0));

	/* Create initial population */
	for (i=0; i<pop; ++i) {
		v[i] = rand();
	}

	do {
		/* Evaluate metric */
		for (i=0; i<pop; ++i) {
			m[i] = f(v[i]);
		}

		/* Pick best*/
		best = 0;
		for (i=1; i<pop; ++i) {
			if (m[i] > m[best]) {
				best = i;
			}
		}
		printf("best of gen %d is %d -> %f\n", gen, v[best], m[best]);

		/* Tournament selection of loosers...
		   basically a sloppy partial sort
		*/
		for (i=0; i<pop; ++i) {
			int r = (rand() % pop);
			if ((m[i] < m[r]) == (i < r)) {
				val vt = v[i];
				double mt = m[i];
				v[i] = v[r];
				m[i] = m[r];
				v[r] = vt;
				m[r] = mt;
			}
		}

		/* Replace bottom guys with crossovers */
		for (i=pop-cross; i<pop; ++i) {
			int a = (rand() % (pop-cross));
			int b = (rand() % (pop-cross));
			int pos = 1 + (rand() % (VALBITS - 1));
			val mask = ((1 << pos) - 1);
			v[i] = ((v[a] & mask) | (v[b] & ~mask));
		}

		/* Replace some more with mutants */
		for (i=pop-cross-mut; i<pop-cross; ++i) {
			int a = (rand() % (pop-cross));
			int pos = (rand() % VALBITS);
			val mask = ((1 << pos) - 1);
			v[i] = v[a] ^ mask;
		}
	} while (++gen < gens);
}
